/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */
 
var interval;
var keyboard;
var mouse;

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    version.innerText += " " + widget.system("defaults read ~/Library/Widgets/BatteryLevel.wdgt/Info CFBundleVersion", null).outputString;
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    clearInterval(interval);
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    interval = setInterval("ioreg()", 10000);
    ioreg();
}

function ioreg() {
    if (keyboard != "old") {
        widget.system("/usr/sbin/ioreg -d 12 -n AppleBluetoothHIDKeyboard", updateKeyboard);
    }
    else {
        widget.system("/usr/sbin/ioreg -d 12 -n IOAppleBluetoothHIDDriver", updateKeyboard);
    }
    
    if (mouse != "old") {
        widget.system("/usr/sbin/ioreg -d 12 -n BNBMouseDevice", updateMouse);
    }
    else {
        widget.system("/usr/sbin/ioreg -d 12 -n AppleBluetoothHIDMouse", updateMouse);
    }
    
    widget.system("/usr/sbin/ioreg -d 12 -n BNBTrackpadDevice", updateTrackpad);
    
    /*
    //DEBUG
    text1.style.color = "#f0f0f0";
    text2.style.color = "#f0f0f0";
    text3.style.color = "#f0f0f0";
    
    percent1.innerText = "100%";
    percent2.innerText = "100%";
    percent3.innerText = "100%";
    
    percent1.innerText = "13%";
    percent2.innerText = "42%";
    percent3.innerText = "7%";
    document.getElementById("indicator1").object.setValue(85);
    document.getElementById("indicator2").object.setValue(50);
    document.getElementById("indicator3").object.setValue(95);
    */
}

function updateKeyboard(output) {
    output = output.outputString;
                
    if (keyboard == undefined) {
        if (output.match(/AppleBluetoothHIDKeyboard/)) {
            keyboard = "new";
        }
        else if (output.match(/IOAppleBluetoothHIDDriver/)) {
            keyboard = "old";
        }
    }

    if (output.match(/AppleBluetoothHIDKeyboard|IOAppleBluetoothHIDDriver/)) {
        text1.style.color = "#f0f0f0";
        try {
            var batteryPercent = output.match(/.BatteryPercent. = \d+/);
            batteryPercent = batteryPercent[0].match(/\d+/);
            document.getElementById("indicator1").object.setValue((batteryPercent-100)*-1);
            percent1.innerText = batteryPercent + "%";
            image1.style.visibility = "hidden";
        }
        catch(err) {
            image1.style.visibility = "visible";
        }
    }
    else {
        document.getElementById("indicator1").object.setValue(-1);
        percent1.innerText = "";
        text1.style.color = "#777";
    }
}

function updateMouse(output) {
    output = output.outputString;
    
    
    if (mouse == undefined) {
        if (output.match(/BNBMouseDevice/)) {
            mouse = "new";
        }
        else if (output.match(/AppleBluetoothHIDMouse/)) {
            mouse = "old";
        }
    }

    if (output.match(/BNBMouseDevice|AppleBluetoothHIDMouse/)) {
        text2.style.color = "#f0f0f0";
        try {
            var batteryPercent = output.match(/.BatteryPercent. = \d+/);
            batteryPercent = batteryPercent[0].match(/\d+/);
            document.getElementById("indicator2").object.setValue((batteryPercent-100)*-1);
            percent2.innerText = batteryPercent + "%";
            image2.style.visibility = "hidden";
        }
        catch(err) {
            image2.style.visibility = "visible";
        }
    }
    else {
        document.getElementById("indicator2").object.setValue(-1);
        percent2.innerText = "";
        text2.style.color = "#777";
    }
}

function updateTrackpad(output) {
    output = output.outputString;
            
    if (output.match(/BNBTrackpadDevice/)) {
        text3.style.color = "#f0f0f0";
        try {
            var batteryPercent = output.match(/.BatteryPercent. = \d+/);
            batteryPercent = batteryPercent[0].match(/\d+/);
            document.getElementById("indicator3").object.setValue((batteryPercent-100)*-1);
            percent3.innerText = batteryPercent + "%";
            image3.style.visibility = "hidden";
        }
        catch(err) {
            image3.style.visibility = "visible";
        }
    }
    else {
        document.getElementById("indicator3").object.setValue(-1);
        percent3.innerText = "";
        text3.style.color = "#777";
    }
}

function showWebsite(event) {
    widget.openURL("http://markusweimar.de/software_en/batterylevel");
}


function reload(event) {
    show();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
